unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls;

type
  PrecBDEEntry = ^TrecBDEEntry;
  TrecBDEEntry = Record
    sNodeName: AnsiString;
    sDescription: AnsiString;
    sValue: AnsiString;
    bHasSubnodes: Boolean;
    End;

  TForm1 = class(TForm)
    TreeView1: TTreeView;
    Panel1: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure TreeView1Expanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure TreeView1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    Procedure CleareList(var AList: TList);
    Procedure GetList(sPath: AnsiString; var AList: TList);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}
USES BDE, DBTables;

Procedure TForm1.CleareList(var AList: TList);
Var
   iI: Integer;
   p: PrecBDEEntry;
Begin
     For iI:=0 To AList.Count-1 Do Begin
         p := AList[iI];
         If p <> NIL Then Dispose(p);
         End;
     AList.Clear;
End;

Procedure TForm1.GetList(sPath: AnsiString; var AList: TList);
Var
   Cursor: HDBICur;
   ConfigDesc: CFGDesc;
   p: PrecBDEEntry;
Begin
     CleareList(AList);
     dbiOpenCfgInfoList(nil, dbiREADONLY, cfgPERSISTENT, PChar(sPath), Cursor);
     While DbiGetNextRecord(Cursor, dbiWRITELOCK, @ConfigDesc, nil) = 0 Do Begin
           New(p);
           p.sNodeName := ConfigDesc.szNodeName;
           p.sDescription := ConfigDesc.szDescription;
           p.sValue := ConfigDesc.szValue;
           p.bHasSubnodes := ConfigDesc.bHasSubnodes;
           AList.Add(p);
           End;
     dbiCloseCursor(Cursor);
End;

procedure TForm1.FormActivate(Sender: TObject);
Var
   iI, iC: Integer;
   AList: TList;
   p: PrecBDEEntry;
   pv: SYSVersion ;
   Node: TTreeNode;
begin
     dbiInit(NIL);
     Label1.Caption := '';
     Label2.Caption := '';
     Label3.Caption := '';
     dbiGetSysVersion(pv);
     Label4.Caption := ' BDE ''' + IntToStr(pv.iVersion) + '''';
     Label5.Caption := '   ''' + IntToStr(pv.iIntfLevel) + '''';
     AList := TList.Create;
     SELF.GetList('\', AList);
     For iI:=0 To AList.Count-1 Do Begin
         p := AList[iI];
         Node := TreeView1.Items.AddChildObjectFirst(NIL, p.sNodeName, p);
         If p.bHasSubnodes Then TreeView1.Items.AddChild(Node, '');
         End;
     AList.Free;
end;

procedure TForm1.TreeView1Expanding(Sender: TObject; Node: TTreeNode; var AllowExpansion: Boolean);
Var
   sPath: AnsiString;
   MyNode, ParentNode: TTreeNode;
   p: PrecBDEEntry;
   AList: TList;
   iI: Integer;
begin
     Node.DeleteChildren;
     AList := TList.Create;
     sPath := '\' + Node.Text;
     MyNode := Node;
     While MyNode.Level > 0 Do Begin
        ParentNode := MyNode.Parent;
        sPath := '\' + ParentNode.Text + sPath;
        MyNode := ParentNode;
        End;
     SELF.GetList(sPath, AList);
     For iI:=0 To AList.Count-1 Do Begin
         p := AList[iI];
         MyNode := TreeView1.Items.AddChildObjectFirst(Node, p.sNodeName, p);
         If p.bHasSubnodes Then TreeView1.Items.AddChild(MyNode, '');
         End;
     AList.Free;
end;

procedure TForm1.TreeView1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var
   Node: TTreeNode;
   p: PrecBDEEntry;
begin
     If Button = mbLeft Then Begin
        Node := TreeView1.GetNodeAt(X, Y);
        If Node = NIL Then EXIT;
        p := Node.Data;
        Label1.Caption := Node.Text;
        Label2.Caption := p.sValue;
        Label3.Caption := p.sDescription;
        End;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     dbiExit;
end;

end.
